.nolist
include \masm32\include\masm32rt.inc

.code
start:
	print chr$("Short version:", 13, 10)
	call ShowCPU

	print chr$(13, 10, "Full version:", 13, 10)
	push -127
	call ShowCPU
	getkey
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCPU proc

; Usage:

; call ShowCPU for the short,

; push -127
; call ShowCPU for the long version

  push ebx
  ifndef MyCPU
	.data?
	CpuFlags		dd ?
	CpuExFlags	dd ?
	CpuMMX	dd ?
	CpuSSE	dd ?
	CpuFxSR	dd ?
	CpuManu	dd 20 dup (?)
	CpuInfo	dd 100 dup (?)
	stepping	dd ?
	model	dd ?
	family	dd ?
	ptype	dd ?
	extmodel	dd ?
	extfamily	dd ?
	.data
	txStep	db "Step           ", 9, 0
	txModel	db 13, 10, "Model        ", 9, 0
	txFam	db 13, 10, "Family       ", 9, 0
	txType	db 13, 10, "Type          ", 9, 0
	txExtM	db 13, 10, "Ext model   ", 9, 0
	txExtF	db 13, 10, "Ext family   ", 9, 0
	txCpuMan	db 13, 10, "Manufacturer", 9, 0
	txP1	db "P1 (1993+)", 0
	txPro	db "Pentium Pro (1995+)", 0
	txP2	db "P2 (1997+)", 0
	txP3	db "P3 (2000+)", 0
	txP4	db "P4 (2000+)", 0
	txIta1	db "Itanium 1 (2001+)", 0
	txIta2	db "Itanium 2 (2002+)", 0
	txPM	db "Pentium M (2003+)", 0
	txCore	db "Core (2006+)", 0
	txCore2	db "Core Duo (2006+)", 0
	txP4Prescott	db "Pentium 4 Prescott (2005+)", 0
	txUnknownP4	db "Pentium 4 (?)", 0
	txUnknown	db "?", 0
	.code
  endif
  xor eax, eax
  db 0Fh, 0A2h		; cpuid 0
  mov CpuManu, ebx
  mov CpuManu[4], edx
  mov CpuManu[8], ecx
  push 1
  pop eax
  db 0Fh, 0A2h	; 					; cpuid 1
  mov CpuFlags, edx
  mov CpuExFlags, ecx
  and CpuMMX, 0
  and CpuSSE, 0

  mov ebx, eax
  and eax, 15
  mov stepping, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov model, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov family, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov ptype, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov extmodel, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov extfamily, eax

  invoke lstrcpy, offset CpuInfo, offset txStep
  invoke lstrcat, offset CpuInfo, str$(stepping)
  
  invoke lstrcat, offset CpuInfo, offset txModel
  invoke lstrcat, offset CpuInfo, str$(model)

  invoke lstrcat, offset CpuInfo, offset txFam
  invoke lstrcat, offset CpuInfo, str$(family)

  invoke lstrcat, offset CpuInfo, offset txType
  invoke lstrcat, offset CpuInfo, str$(ptype)

  invoke lstrcat, offset CpuInfo, offset txExtM
  invoke lstrcat, offset CpuInfo, str$(extmodel)

  invoke lstrcat, offset CpuInfo, offset txExtF
  invoke lstrcat, offset CpuInfo, str$(extfamily)

  invoke lstrcat, offset CpuInfo, offset txCpuMan
  invoke lstrcat, offset CpuInfo, offset CpuManu

  mov eax, [esp+8]
  .if eax==-127
	print "CPU family ",
	print str$(family), ", model "
	print str$(model), ", "
  .endif
  
  COMMENT @
[url=http://www.pagetable.com/?p=18]CPUID Family codes[/url]
* 486 (1989): family 4
* Pentium (1993): family 5
* Pentium Pro (1995): family 6, models 0 and 1
* Pentium 2 (1997): family 6, models 3, 5 and 6
* Pentium 3 (2000): family 6, models 7, 8, 10, 11
* Itanium (2001): family 7
* Pentium 4 (2000): family 15/0
* Itanium 2 (2002): family 15/1 and 15/2
* Pentium M (2003): family 6, models 9 and 13
* Core (2006): family 6, model 14
* Core 2 (2006): family 6, model 15 @
  .if family==5
	mov edx, offset txP1
  .elseif family==6
	.if model<=1
		mov edx, offset txPro
	.elseif model==3 || model==5 || model==6
		mov edx, offset txP2
	.elseif model==7 || model==8 || model==10 || model==11
		mov edx, offset txP3
	.elseif model==9 || model==13
		mov edx, offset txPM
	.elseif model==14
		mov edx, offset txCore
	.elseif model==15
		mov edx, offset txCore2
	.endif
  .elseif family==7	; Itanium
		mov edx, offset txIta1
  .elseif family==15
	.if model==0
		mov edx, offset txP4
	.elseif model<=2
		mov edx, offset txIta2
	.elseif model==4
		mov edx, offset txP4Prescott
	.else
		mov edx, offset txUnknownP4
	.endif
  .else
	mov edx, offset txUnknown
  .endif
  print edx
  mov edx, CpuFlags
  ; MsgBox 0, BIN$(edx, f), "Hi", MB_OK
  bt edx, 23
  .if Carry?
	inc CpuMMX
	print ", MMX, SSE"
  .else
	print ", no MMX, SSE"
  .endif

  mov edx, CpuFlags
  bt edx, 24
  jnc @F
  inc CpuFxSR	; supports FXSAVE, FXRSTOR
@@:

  bt edx, 25
  jnc @F
  inc CpuSSE
@@:

  bt edx, 26
  jnc @F
  inc CpuSSE
@@:

  mov ecx, CpuExFlags
  bt ecx, 0
  jnc @F
  inc CpuSSE
@@:
  print str$(CpuSSE), 13, 10
  pop ebx
  mov eax, [esp+4]
  .if eax==-127
	print offset CpuInfo, 13, 10
	ret 4
  .else
	ret
  .endif
ShowCPU endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
end start

[url=http://en.wikipedia.org/wiki/CPUID]EAX=1: Processor Info and Feature Bits[/url]

This returns the CPU's stepping, model, and family information in EAX (also called the signature of a CPU), feature flags in EDX and ECX, and additional feature info in EBX.

The format of the information in EAX is as follows:

    * 3:0 - Stepping
    * 7:4 - Model
    * 11:8 - Family
    * 13:12 - Processor Type
    * 19:16 - Extended Model
    * 27:20 - Extended Family


[url=http://www.codinghorror.com/blog/archives/000364.html]Nasty Software Hacks and Intel's CPUID[/url]

Intel decided to make a new family code for the Pentium 4. That's where the fun begins.

The average person would think Intel would just increment the family code, making the Pentium 4 part of 'family 7'.
That does make sense, but Intel already has a family code 7 processor : the Itanium (it came before the Pentium 4,
even though the P4 hit the market first). Ok, no problem. Just make the Pentium 4's family code 8 instead of 7.

Wrong. Big problem.

Microsoft Windows NT 4.0 ran into a bit of a snag with "family 8." For those not schooled in the ways of binary,
the decimal number 8 is "1000" in binary. That's four binary digits. Four bits.

Four bits. Remember that, because it's important.

When Windows NT 4.0 and its six service packs were released, the largest CPU family code was 6.
That's "110" in binary. Only three bits. So the NT code only looks at the first three bits of the CPU family
when configuring the system.

If you haven't figured it out by now, the first three bits of 8 are zero, zero and, you guessed it, zero.
Windows NT goes wacko when it sees a CPU family zero. Serious wacko. Jack with an axe at the end of The Shining wacko.

OPT_WAIT	1	; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
